'----------------------------------------------------------------------------------------
'---  FILE:       REMOVE_ACIDPROCS.VBS
'---              Microsoft TPC-E Kit Ver. 1.12.0-1025
'---              Copyright Microsoft 2008, 2009
'---              All Rights Reserved
'---
'---  PURPOSE:    This module removes the TPC-E ACID Stored Procedure
'---
'----------------------------------------------------------------------------------------
'------------------------------------
'--- open an windows scripting object
'------------------------------------
set WshShell = CreateObject("WScript.Shell")
'-----------------------------------------------------
'--- set up windows scripting argument collection
'-----------------------------------------------------
Set objArgs = wScript.Arguments
'------------------------------------------
'--- open a file system object
'------------------------------------------
Set fs = CreateObject("Scripting.FileSystemObject")
'-----------------------------
'--- set the test particulars
'-----------------------------
Kit_Version = "  1.12.0-1025"
Test_Name = "ACID Stored Procedures"
Header_Line = "*  Removing TPC-E ACID Stored Procedures...                               *"
Footer_Line = "*  TPC-E ACID Stored Procedures Removed.                                  *"
Status_Line = "Removing ACID Stored Procedures..."
'------------------------------------
'--- display banner message
'------------------------------------
wScript.Echo "****************************************************************************"
wScript.Echo "*                                                                          *"
wScript.Echo "*  Microsoft TPC-E Benchmark Kit Ver." & Kit_Version & "                         *"
wScript.Echo "*                                                                          *"
wScript.Echo Header_Line
wScript.Echo "*                                                                          *"
wScript.Echo "****************************************************************************"
wScript.Echo FormatDateTime(Now,2) & " " &  FormatDateTime(Now,3) & " ==> TPC-E ACID Procedure Installation Start Time."
'----------------------------------------------
'--- build array of Acid stored procedure names
'----------------------------------------------
Dim AcidProcArray(14)
AcidProcArray(0) = "TradeOrder_C"
AcidProcArray(1) = "TradeOrder_RB"
AcidProcArray(2) = "TradeOrder_Iso1_1"
AcidProcArray(3) = "TradeOrder_Iso1_2"
AcidProcArray(4) = "TradeOrder_Iso2"
AcidProcArray(5) = "TradeOrder_Iso3"
AcidProcArray(6) = "TradeOrder_Iso4"
AcidProcArray(7) = "TradeResult_Iso1_1"
AcidProcArray(8) = "TradeResult_Iso1_2"
AcidProcArray(9) = "TradeResult_Iso2_1"
AcidProcArray(10) = "TradeResult_Iso2_2"
AcidProcArray(11) = "TradeResult_Iso3"
AcidProcArray(12) = "TradeResult_Iso4"
AcidProcArray(13) = "CustomerPosition_Iso3"
AcidProcArray(14) = "CustomerPosition_Iso4"
'------------------------------------
'--- grab the current directory value
'------------------------------------
AcidProcDirectory = WshShell.CurrentDirectory & "\"
'----------------------------------------
'--- grab the Computer Name from Windows
'----------------------------------------
ServerName = WshShell.ExpandEnvironmentStrings("%COMPUTERNAME%")
'----------------------------------------------
'--- prompt the user to confirm the server name
'----------------------------------------------
ServerName = InputBox("Enter your server name",Test_Name,ServerName)
Do While ServerName = ""
	rc = MsgBox ("You must enter a valid server name.",21)
	If rc = 2 Then
		wScript.Echo ""
		wScript.Echo "TPC-C Setup cancelled by user."
		wScript.Quit
	End If	
	ServerName = WshShell.ExpandEnvironmentStrings("%COMPUTERNAME%")
	ServerName = InputBox("Enter your server name","Database Server Name",ServerName)
Loop
SQLAuthentication = MsgBox("Use Windows Authentication to connect to" & _
                        Chr(13) & "SQL Server?",3,"SQL Server Login Method")
Select Case SQLAuthentication
    Case 6
        SQLAuthentication = "Windows"
    Case 7
        SQLAuthentication = "SQLServer"
    Case 2
        wScript.Echo ""
        wScript.Echo GenerateDateTimeStamp("True") & " ==> TPC-E Setup cancelled by user."
        wScript.Quit
End Select
If SQLAuthentication = "SQLServer" Then
    SQLUserID = InputBox("Enter the SQL Server User ID to use:", "TPC-E Setup (V" & Kit_Version & ")", "sa")
    Do While SQLUserID = ""
        rc = MsgBox("You must enter a valid SQL Server User ID.", 21)
        If rc = 2 Then
            wScript.Echo ""
            wScript.Echo GenerateDateTimeStamp("True") & " ==> TPC-E Setup cancelled by user."
            wScript.Quit
        End If
        SQLUserID = InputBox("Enter the SQL Server User ID to use:", "TPC-E Setup (V" & Kit_Version & ")", "sa")
    Loop
    SQLPassword = InputBox("Enter the SQL Server password for " & SQLUserID & ": " & _
                        Chr(13) & Chr(13) & "NOTE: We strongly recommend that you do not use a blank password for the account." & _
                        Chr(13) & "If you choose to ignore this recommendation," & _
                        Chr(13) & "then please press the spacebar in lieu of the password.", "TPC-E Setup (V" & Kit_Version & ")")
    If SQLPassword = " " or LCase(SQLPassword) = "blank" or SQLPassword = "" Then
        SQLPassword = "BLANK"
    Else
        Do While SQLPassword = ""
            rc = MsgBox("You must enter a valid SQL Server Password. (Blank is NOT recommended.)", 21)
            If rc = 2 Then
                wScript.Echo ""
                wScript.Echo GenerateDateTimeStamp("True") & " ==> TPC-E Setup cancelled by user."
                wScript.Quit
            End If
            SQLPassword = InputBox("Enter the SQL Server password for " & SQLUserID & ": " & _
								Chr(13) & Chr(13) & "NOTE: We strongly recommend that you do not use a blank password for the 'sa' account." & _
								Chr(13) & "If you choose to ignore this recommendation," & _
								Chr(13) & "then please press the spacebar in lieu of the password.", "TPC-E Setup (V" & Kit_Version & ")")
            If SQLPassword = " " or LCase(SQLPassword) = "blank" or SQLPassword = "" Then
                SQLPassword = "BLANK"
            End If
        Loop
    End If
    SQLLogin = "SQLCMD -U" & SQLUserID & " -P" & SQLPassword & " -S"
Else
	SQLLogin = "SQLCMD -E -S"
End If
'-------------------------------------------------------
'--- setup the objects for the concatenated results file
'-------------------------------------------------------
Set Results_FSO = CreateObject("Scripting.FileSystemObject")
Set Results_File = Results_FSO.CreateTextFile(AcidProcDirectory & "Remove_AcidProcs.out",true)
'------------------------
'--- now get to work
'------------------------
wScript.Echo ""
wScript.Echo Status_Line
For i = 0 to UBOUND(AcidProcArray)
	wScript.Echo ""
	wScript.Echo "Removing " & AcidProcArray(i) & "..."
	BuildDropScript(AcidProcArray(i))
	Cmd_String = "SQLCMD " & strSQL_Login & " -S" & ServerName & " -e -i" & AcidProcDirectory & "scripts\Drop_SPROC.sql -o" & AcidProcDirectory & "Drop_SPROC.out"
	Set oExec = WshShell.Exec(CMD_String)
	Do While oExec.Status = 0
		WScript.Sleep 100
	Loop
	rc = CheckSQLOutput(AcidProcDirectory & "Drop_SPROC.out")
	If rc <> 0 Then
		Wscript.Quit
	End If
	Set Temp_Results_File = Results_FSO.OpenTextFile(AcidProcDirectory & "Drop_SPROC.out")
	Do While Temp_Results_File.AtEndOfStream <> True
		'----------------------------------------------------------------
		'--- read in a line and write it to the concatenated results file
		'----------------------------------------------------------------
		Results_File.WriteLine Temp_Results_File.ReadLine
	Loop
	Temp_Results_File.Close
	'------------------------------------
	'--- now remove the temporary file
	'------------------------------------
	Results_FSO.DeleteFile(AcidProcDirectory & "Drop_SPROC.out")
Next
Results_File.Close
wScript.Echo ""
wScript.Echo "****************************************************************************"
wScript.Echo "*                                                                          *"
wScript.Echo "*  Microsoft TPC-E Benchmark Kit Ver." & Kit_Version & "                         *"
wScript.Echo "*                                                                          *"
wScript.Echo Footer_Line
wScript.Echo "*                                                                          *"
wScript.Echo "****************************************************************************"
wScript.Echo FormatDateTime(Now,2) & " " &  FormatDateTime(Now,3) & " ==> TPC-E ACID Procedure Installation Complete."
wScript.Echo ""
wScript.Quit(0)
'---------------------------------------------------
'--- define function to check for any error messages
'---------------------------------------------------
Function CheckSQLOutput(SQL_Out)
	ErrorFlag = 0
	Set SQL_fso = CreateObject("Scripting.FileSystemObject")
	Set SQL_Out_File = SQL_fso.OpenTextFile(SQL_Out,1)
	Do While SQL_Out_File.AtEndOfStream <> True
		SQL_Line = SQL_Out_File.ReadLine
		'first check to see if SQL Server is running
		If InStr(SQL_Line, "[Shared Memory]General network error.") Then
			'display the messages and get out of here
			ErrorFlag = 1
			Wscript.Echo "SQL Server does not appear to be active on " & ServerName & "."
			Wscript.Echo "Please check the SQL Server instance and restart the ACID Procedures installation."
		End If
		'next check to see if the output contains a message about the login password
		If InStr(SQL_Line, "Login failed") Then
			'display the messages and get out of here
			ErrorFlag = 1
			Wscript.Echo "The login for userid 'sa' failed."
			Wscript.Echo "Please restart the ACID Procedures installation."
		End If
    Loop
	SQL_Out_File.Close
	CheckSQLOutput = ErrorFlag
End Function
'---------------------------------------------------
'--- end function
'---------------------------------------------------
'---------------------------------------------------
'--- define function to check for any error messages
'---------------------------------------------------
Sub BuildDropScript(SQL_SPROC_Name)
    SQLFileSpecOut = AcidProcDirectory & "Scripts\Drop_SPROC.sql"
	'-----------------------------------------------------
	'--- now start parsing the file
	'-----------------------------------------------------
	Set SQLFileOut = fs.OpenTextFile(SQLFileSpecOut,2,True)
	SQLFileOut.WriteLine("USE tpce")
	SQLFileOut.WriteLine("GO")
	SQLFileOut.WriteLine("IF EXISTS (SELECT name FROM sysobjects WHERE name = '" & SQL_SPROC_Name & "' )")
	SQLFileOut.WriteLine("DROP PROCEDURE " & SQL_SPROC_NAME)
	SQLFileOut.WriteLine("GO")
    SQLFileOut.Close
End Sub
'---------------------------------------------------
'--- end function
'---------------------------------------------------
